<!doctype html>
<html>
<head>
<meta charset="utf-8">

<script type="text/javascript" src="brython.js"></script>
<script type="text/javascript" src="brython_stdlib.js"></script>

<script id="python_script" type="text/python">
import tb as traceback
import javascript
import sys
import io

from browser import document, timer

""" Set the output wrapper for the SVG rendered by Graphviz """
from graphviz.dot import set_defaults
document["graph-div"].html = ''
set_defaults(viz_wrapper = document["graph-div"]) 

FIRST_TIME = True
def inform(*args):
    document["status-info"].html = "".join(args)

def clear_print():
    document["print-output"].html = ""

def run_code(ev):
     clear_print()
     
     s = io.StringIO()
     k = io.StringIO()

     src = document["source"].text 

     sys.stdout = s

     try:
         in_globals = True
         ns = {'__name__':'__main__'}
         exec(src, ns)
         e = s.getvalue()
         document["print-output"] <= e

     except Exception as exc:

         sys.stdout = k
         ecp = traceback.format_exc()
         print(ecp)
         document["print-output"] <= k.getvalue()

document["run"].bind("click", run_code)

</script>

<style>
  h1, h2, h3, h4 {
    color: blue;
  }
  pre {
    max-width: 800px;
    overflow: auto;
    word-break: normal !important;
    word-wrap: normal !important;
    white-space: pre !important;
    font-weight: bold;
  }
  pre#source {
    border: 1px solid blue;
    background-color:antiquewhite;
  }
  pre#turtle-docstring {
    background-color: white;
    max-width: 800px;
  }
  hr {
    clear: both;
  }
  #info {
    max-width: 800px;
    border: 1px dotted black;
  }

  pre#turtle-print-output {
    background-color: black;
    color: yellow;
    font-weight: bolder;
    min-height: 50px;
    height: auto;
    max-height: 200px;
  }

  button {
    margin: 20px;
    padding: 10px;
  }
  #status-info {
    color: darkred;
    font-weight: bolder;
  }
  .error, .not-implemented {
    color: red;
  }
  .btn-enabled {
    color: black;
    background-color: #c0c0c0;
  }

  .btn-disabled {
    cursor: not-allowed;
    pointer-events: none;
    color: #c0c0c0;
    background-color: #ffffff;
  }
</style>

</head>

<body onload="brython(1)">
<h1>Graphviz demo</h1>


<br>
Note that the content is editable.
</p>
<div id="info"></div>

<p><button id="run" class="btn-enabled">Run</button> <span id="status-info"></span>

  
<pre id="print-output"></pre>

<pre id="source" style="float:left" contenteditable="true">
from graphviz import Digraph

g = Digraph()

g.edges(['AB', 'AF', 'BD', 'DE', 'CE'])
g.edge('E','F', label = '3')

g.view(engine="circo")



</pre>

<div id="graph-div" style="float:left;border:1px solid green; margin-left:50px;"> </div>

<div id="status-info"></div>

</body>

</html>
